﻿Imports System.Data
Imports System.Configuration
Imports MySql.Data.MySqlClient
Partial Class VB
    Inherits System.Web.UI.Page

    Private PageSize As Integer = 10
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.GetCustomersPageWise(1)
        End If
    End Sub

    Private Sub GetCustomersPageWise(pageIndex As Integer)
        Dim constring As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New MySqlConnection(constring)
            Using cmd As New MySqlCommand("GetCustomers_Pager", con)
                cmd.CommandType = CommandType.StoredProcedure
                cmd.Parameters.AddWithValue("_PageIndex", pageIndex)
                cmd.Parameters.AddWithValue("_PageSize", PageSize)
                cmd.Parameters.Add("_RecordCount", MySqlDbType.Int32, 4)
                cmd.Parameters("_RecordCount").Direction = ParameterDirection.Output
                con.Open()
                Using idr As IDataReader = cmd.ExecuteReader()
                    gvCustomers.DataSource = idr
                    gvCustomers.DataBind()
                End Using
                con.Close()
                Dim recordCount As Integer = Convert.ToInt32(cmd.Parameters("_RecordCount").Value)
                Me.PopulatePager(recordCount, pageIndex)
            End Using
        End Using
    End Sub

    Private Sub PopulatePager(recordCount As Integer, currentPage As Integer)
        Dim pages As New List(Of ListItem)()
        Dim startIndex As Integer, endIndex As Integer
        Dim pagerSpan As Integer = 5

        'Calculate the Start and End Index of pages to be displayed.
        Dim dblPageCount As Double = CDbl(CDec(recordCount) / Convert.ToDecimal(PageSize))
        Dim pageCount As Integer = CInt(Math.Ceiling(dblPageCount))
        startIndex = If(currentPage > 1 AndAlso currentPage + pagerSpan - 1 < pagerSpan, currentPage, 1)
        endIndex = If(pageCount > pagerSpan, pagerSpan, pageCount)
        If currentPage > pagerSpan Mod 2 Then
            If currentPage = 2 Then
                endIndex = 5
            Else
                endIndex = currentPage + 2
            End If
        Else
            endIndex = (pagerSpan - currentPage) + 1
        End If

        If endIndex - (pagerSpan - 1) > startIndex Then
            startIndex = endIndex - (pagerSpan - 1)
        End If

        If endIndex > pageCount Then
            endIndex = pageCount
            startIndex = If(((endIndex - pagerSpan) + 1) > 0, (endIndex - pagerSpan) + 1, 1)
        End If

        'Add the First Page Button.
        If currentPage > 1 Then
            pages.Add(New ListItem("First", "1"))
        End If

        'Add the Previous Button.
        If currentPage > 1 Then
            pages.Add(New ListItem("<<", (currentPage - 1).ToString()))
        End If

        For i As Integer = startIndex To endIndex
            pages.Add(New ListItem(i.ToString(), i.ToString(), i <> currentPage))
        Next

        'Add the Next Button.
        If currentPage < pageCount Then
            pages.Add(New ListItem(">>", (currentPage + 1).ToString()))
        End If

        'Add the Last Button.
        If currentPage <> pageCount Then
            pages.Add(New ListItem("Last", pageCount.ToString()))
        End If
        rptPager.DataSource = pages
        rptPager.DataBind()
    End Sub

    Protected Sub Page_Changed(sender As Object, e As EventArgs)
        Dim pageIndex As Integer = Integer.Parse(TryCast(sender, LinkButton).CommandArgument)
        Me.GetCustomersPageWise(pageIndex)
    End Sub
End Class


